package views.mediators
{
	import flash.events.MouseEvent;
	
	import models.ViewModel;
	
	import org.robotlegs.mvcs.Mediator;
	
	import signals.ChangeViewSignal;
	
	import views.components.ViewOne;
	
	public class ViewOneMediator extends Mediator
	{
		/**
		 * Main View
		 */
		[Inject]
		public var view:ViewOne;
		
		/**
		 * Models 
		 */
		[Inject]
		public var viewModel:ViewModel;
		
		/**
		 * Signals send / received by the view
		 */
		[Inject]
		public var viewSignal:ChangeViewSignal;
		
		override public function onRegister( ):void
		{
			eventMap.mapListener(view.btnView, MouseEvent.CLICK, onMouseClick, MouseEvent); 
			if(contextView.contains(view))
				viewModel.currentView = view;
		}
		
		override public function onRemove():void
		{
			trace("view 1 mediator removed");
			super.onRemove();
			
			eventMap.unmapListeners();
			
			if ( contextView.contains(view) ) 
				trace("viewOne is still there !");
		}
		
		private function onMouseClick(evt:MouseEvent):void
		{
			viewModel.nextView = "viewTwo";
			viewSignal.dispatch();
		}
	}
}